import 'dart:convert';

import 'exceptions.dart';

class Era {
  final String name;

  const Era({
    this.name,
  });

  factory Era.fromString(String source) {
    try {
      return Era.fromJson(jsonDecode(source));
    } on FormatException {
      throw JsonSourceException('FormatException reading era', source);
    } on TypeError {
      throw JsonSourceException('TypeError reading era', source);
    }
  }

  factory Era.fromJson(Map<String, dynamic> json) {
    try {
      return Era(
        name: json['name'],
      );
    } on TypeError {
      throw JsonInputException('TypeError reading era', json);
    }
  }

  String toString() => jsonEncode(toJson());

  Map<String, dynamic> toJson() => {
    'name': name,
  };
}
