import 'dart:convert';

abstract class JsonException implements Exception {}

class JsonSourceException extends JsonException {
  final String message;
  final String source;

  JsonSourceException(this.message, this.source);

  String toString() => 'JsonSourceException: $message\n"$source"';
}

class JsonInputException extends JsonException {
  final String message;
  final Map<String, dynamic> json;

  JsonInputException(this.message, this.json);

  String toString() => 'JsonInputException: $message\n"${jsonEncode(json)}"';
}
