import 'dart:convert';

import 'exceptions.dart';

class Genre {
  final String name;

  const Genre({
    this.name,
  });

  factory Genre.fromString(String source) {
    try {
      return Genre.fromJson(jsonDecode(source));
    } on FormatException {
      throw JsonSourceException('FormatException reading genre', source);
    } on TypeError {
      throw JsonSourceException('TypeError reading genre', source);
    }
  }

  factory Genre.fromJson(Map<String, dynamic> json) {
    try {
      return Genre(
        name: json['name'],
      );
    } on TypeError {
      throw JsonInputException('TypeError reading genre', json);
    }
  }

  String toString() => jsonEncode(toJson());

  Map<String, dynamic> toJson() => {
    'name': name,
  };
}
