import 'dart:convert';

import 'exceptions.dart';

class Key {
  final String name;

  const Key({
    this.name,
  });

  factory Key.fromString(String source) {
    try {
      return Key.fromJson(jsonDecode(source));
    } on FormatException {
      throw JsonSourceException('FormatException reading key', source);
    } on TypeError {
      throw JsonSourceException('TypeError reading key', source);
    }
  }

  factory Key.fromJson(Map<String, dynamic> json) {
    try {
      return Key(
        name: json['name'],
      );
    } on TypeError {
      throw JsonInputException('TypeError reading key', json);
    }
  }

  String toString() => jsonEncode(toJson());

  Map<String, dynamic> toJson() => {
    'name': name,
  };
}
