import 'dart:math';

import 'era.dart';
import 'genre.dart';
import 'key.dart';
import 'musician.dart';
import 'work.dart';

abstract class Library {
  static final _random = Random();
  static int generateId() => _random.nextInt(0xFFFFFFFF);

  Future<int> addEra(Era era);
  Future<int> addMusician(Musician musician);
  Future<int> addGenre(Genre genre);
  Future<int> addKey(Key key);
  Future<int> addWork(Work work);
  
  void updateEra(int id, Era era);
  void updateMusician(int id, Musician musician);
  void updateGenre(int id, Genre genre);
  void updateKey(int id, Key key);
  void updateWork(int id, Work work);

  void deleteEra(int id);
  void deleteMusician(int id);
  void deleteGenre(int id);
  void deleteKey(int id);
  void deleteWork(int id);

  Future<Era> getEra(int id);
  Future<Musician> getMusician(int id);
  Future<Genre> getGenre(int id);
  Future<Key> getKey(int id);
  Future<Work> getWork(int id);

  Future<Iterable<int>> getEras();
  Future<Iterable<int>> getMusicians();
  Future<Iterable<int>> getGenres();
  Future<Iterable<int>> getKeys();
  Future<Iterable<int>> getWorks();
}
